#include <iostream>
#include <cstring>

using namespace std;
int getTraverseSize();
void readAngles(double [], int);
double getSum(double [], int);
void correct(double [], int, double);
void print(double [], int);
const int N = 100;

int main() {

    // Declarations
    double a[N];
    int n, i;
    double tsum, sum, error, correction;

    // Reading traverse size
    n = getTraverseSize();

    // Reading angles values
    readAngles(a, n);

    // Calculating angles sum
    sum = getSum(a, n);

    // Calculating correction
    tsum = 180 * (n - 2);
    error = sum - tsum;
    correction = error / n;

    // Correcting angles
    correct(a, n, correction);

    // Printing corrected angles
    cout << "Error = " << error << endl;
    cout << "Correction = " << correction << endl;
    cout << "Corrected angles:" << endl;
    print(a, n);
}

int getTraverseSize() {
    int n;
    do {
        cout << "How many angles [3," << N << "]? ";
        cin >> n;
        if (n < 3) {
            cout << "Too few angles!" << endl;
        }
        if (n > N) {
            cout << "Too many angles!" << endl;
        }
    } while (n < 3 || n > N);
    return n;
}

void readAngles(double a[], int n) {
    cout << "Enter " << n << " angles:" << endl;
    for (int i = 0; i <= n - 1; i += 1) {
        do {
            cout << "Angle " << i + 1 << " (0,360): ";
            cin >> a[i];
            if (a[i] <= 0 || a[i] >= 360) {
                cout << "Out of range!" << endl;
            }
        } while (a[i] <= 0 || a[i] >= 360);
    }
}

double getSum(double a[], int n) {
    double sum = 0;
    for (int i = 0; i <= n - 1; i += 1) {
        sum = sum + a[i];
    }
    return sum;
}

void correct(double a[], int n, double correction) {
    for (int i = 0; i <= n - 1; i += 1) {
        a[i] = a[i] - correction;
    }
}

void print(double a[], int n) {
    for (int i = 0; i <= n - 1; i += 1) {
        cout << a[i] << endl;
    }
}
